/***************************************************************************
                          dirscanner.h  -  description
                             -------------------
    begin                : Mon Jun 30 2003
    copyright            : (C) 2003 by Elad Lahav
    email                : elad@eldarshany.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef DIRSCANNER_H
#define DIRSCANNER_H

#include <qobject.h>
#include <qevent.h>
#include <qthread.h>
#include <qdir.h>
#include <qstringlist.h>
#include <qdict.h>
#include <qlistview.h>

class DirScanner;

/**
 * @author Elad Lahav
 */
class DirScanEvent : public QCustomEvent
{
public:
	enum { EventId = 6924 };
	
	DirScanEvent(int, bool);

	int m_nFiles;
	bool m_bFinished;
};

/**
 * Scans a directory for files matching a given pattern, using a separate thread.
 * @author Elad Lahav
 */

class DirScanner : public QThread
{
public: 
	DirScanner(QObject*, QDict<QListViewItem>*);
	~DirScanner();

	void start(const QString&, const QString&, bool);
	void cancel() { m_bCancel = true; }

	const QStringList& getFiles() { return m_slFiles; }
	bool wasCancelled() { return m_bCancel; }
	
protected:
	virtual void run();

private:
	QObject* m_pEventReceiver;
	QDir m_dir;
	QDict<QListViewItem>* m_pDicFiles;
	QString m_sNameFilter;
	QStringList m_slFiles;
	bool m_bCancel;
	bool m_bRecursive;
	
	int scanDir(QDir&);
};

#endif
