/***************************************************************************
                          kscopepixmaps.h  -  description
                             -------------------
    begin                : Sat Jul 19 2003
    copyright            : (C) 2003 by Elad Lahav
    email                : elad_lahav@users.sf.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef KSCOPEPIXMAPS_H
#define KSCOPEPIXMAPS_H

#include <qpixmap.h>
#include <kiconloader.h>

/**
 * Handles all pixmaps required by KScope.
 * @author Elad Lahav
 */

class KScopePixmaps
{
public: 
	KScopePixmaps();
	~KScopePixmaps();

	enum PixName { SymFunc, SymVar, SymStruct, SymMacro, SymMember, SymEnum,
		SymEnumerator, SymTypedef, SymUnknown, SortByNameAsc,
		SortByNameDes, SortByLineAsc, SortByLineDes, PIX_ARRAY_SIZE };
		
	enum LoadPixName { ToolbarReload, GoBack, GoForward, ButtonNewQuery,
		ButtonLockQuery, ButtonUnlockQuery, ButtonRefreshQuery, 
		ButtonCloseQuery, TabUnlocked, TabLocked, TabRW, TabRO, TabSave,
		TabFileList, TabFileTree };
	
	void init();
	const QPixmap& getPixmap(PixName name) const
		{ return *m_pPixArray[name]; }
	QPixmap getPixmap(LoadPixName name);
	
private:
	QPixmap** m_pPixArray;
	KIconLoader m_loader;
};

KScopePixmaps& Pixmaps();

#endif
