/***************************************************************************
                          main.cpp  -  description
                             -------------------
    begin                : Fri May  9 09:16:06 IDT 2003
    copyright            : (C) 2003 by Elad Lahav
    email                : elad_lahav@users.sf.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <kcmdlineargs.h>
#include <kaboutdata.h>
#include <klocale.h>

#include "kscope.h"
#include "kscopeconfig.h"

static const char *description =
	I18N_NOOP("KScope\nA source-editing environment for KDE, based on "
	"Cscope");

static KCmdLineOptions options[] =
{
	{ "+[CSCOPE.OUT PATH]", 
		I18N_NOOP("Open a cscope.out file in a temporary project"), 0 },
	KCmdLineLastOption
};

int main(int argc, char *argv[])
{
	KAboutData aboutData( "kscope", I18N_NOOP("KScope"),
		VERSION, description, KAboutData::License_GPL,
		"(c) 2003-2004, Elad Lahav", 0, "http://kscope.sourceforge.net",
		"elad_lahav@users.sf.net");
	aboutData.addAuthor("Elad Lahav", 0, "elad_lahav@users.sf.net");
	KCmdLineArgs::init(argc, argv, &aboutData);
	KCmdLineArgs::addCmdLineOptions(options); // Add our own options.

	// Parse command line arguments
	KCmdLineArgs* pArgs = KCmdLineArgs::parsedArgs();

	KApplication a;
	KScope* kscope = new KScope();
	a.setMainWidget(kscope);

	// Open a cscope.out file, if requested, or the most recent project
	// otherwise
	if (pArgs->count() > 0) {
		kscope->openCscopeOut(pArgs->arg(0));
	}
	else if (Config().getLoadLastProj()) {
		const QStringList slProjects = Config().getRecentProjects();
		
		if (!slProjects.empty())
			kscope->openProject(*slProjects.begin());
	}
	
	kscope->show();  
	return a.exec();
}
