/***************************************************************************
                          querywidget.h  -  description
                             -------------------
    begin                : Thu May 22 2003
    copyright            : (C) 2003 by Elad Lahav
    email                : elad@eldarshany.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef QUERYWIDGET_H
#define QUERYWIDGET_H

#include <qlistview.h>
#include <qpopupmenu.h>
#include <ktabwidget.h>
#include "querywidgetlayout.h"

class QueryPage;

/**
 * A tabbed-window holding Cscope query results pages.
 * @author Elad Lahav
 */

class QueryWidget : public QueryWidgetLayout
{
   Q_OBJECT

public:
	QueryWidget(QWidget* pParent = 0, const char* szName = 0);
	~QueryWidget();

	void initQuery(uint, const QString&);
	void applyPrefs();
	void loadLockedQueries(const QString&, const QStringList&);
	void saveLockedQueries(const QString&, QStringList&);
	void showHideButtons();

	QueryPage* getActivePage();

public slots:
	void slotLockCurrent(bool);
	void slotLockCurrent();
	void slotRefreshCurrent();
	void slotCloseCurrent();
	void slotCloseAll();

signals:
	void lineRequested(const QString&, uint);
	void queryFinished();
	void runQuery(uint, const QString&);
	
private:
	QPopupMenu* m_pPageMenu;
	int m_nLockMenuId;
	int m_nRefreshMenuId;
	int m_nCloseMenuId;
	
	inline QueryPage* currentPage()
		{ return (QueryPage*)m_pQueryTabs->currentPage(); }
	void setPageCaption(QueryPage*);
	
private slots:
	void slotAddQuery();
	void slotRequestLine(QListViewItem*);
	void slotCurrentChanged(QWidget*);
	void slotCloseQuery(QWidget*);
	void slotContextMenu(const QPoint&);
	void slotContextMenu(QWidget*, const QPoint&);
};

#endif
