/***************************************************************************
                          searchlist.h  -  description
                             -------------------
    begin                : Mon May 19 2003
    copyright            : (C) 2003 by Elad Lahav
    email                : elad@eldarshany.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef SEARCHLIST_H
#define SEARCHLIST_H

#include <qwidget.h>
#include <qvbox.h>
#include <qlineedit.h>
#include <qlistview.h>

/**
 * Defines a searchable list view.
 * The widget is composed of a list view, and an edit box used to enter
 * search data. Whenever the text in the edit box changes, the list view is
 * set to point to the first item that matches the new text.
 * @author Elad Lahav
 */

class SearchList : public QVBox
{
   Q_OBJECT

public: 
	SearchList(int nSearchCol, QWidget* pParent = 0, const char* szName = 0);
	~SearchList();

	QListView* getList() { return m_pList; }

protected:
	QLineEdit* m_pEdit;
	QListView* m_pList;

	virtual void processItemSelected(QListViewItem*) = 0;
	
protected slots:
	void slotFindItem(const QString&);
	void slotItemSelected(QListViewItem*);
	void slotItemSelected();
	
private:
	int m_nSearchCol;
};

#endif
